/* Licensed Materials - Property of IBM              */
/* (c) Copyright IBM Corp. 2020. All Rights Reserved.*/

 
package org.opengroup.osdu.legal.ibm.security;

import org.springframework.security.config.annotation.method.configuration.EnableGlobalMethodSecurity;
import org.springframework.security.config.annotation.web.builders.HttpSecurity;
import org.springframework.security.config.annotation.web.configuration.EnableWebSecurity;
import org.springframework.security.config.annotation.web.configuration.WebSecurityConfigurerAdapter;

@EnableWebSecurity
@EnableGlobalMethodSecurity(prePostEnabled = true)
public class SecurityConfig extends WebSecurityConfigurerAdapter {
    @Override
    protected void configure(HttpSecurity http) throws Exception {
        http
                .csrf().disable()
                .authorizeRequests()
                .antMatchers("/_ah/liveness_check","/_ah/readiness_check",
                	"/v2/api-docs",
                    "/configuration/ui",
                    "/swagger-resources/**",
                    "/actuator/**",
                    "/configuration/security",
                    "/swagger-ui.html",
                    "/info",
                    "/webjars/**").permitAll()
                .anyRequest().authenticated().and().oauth2ResourceServer().jwt();
    }
}
